// from http://blogger.ziesemer.com/2007/10/respecting-javascript-global-namespace.html
//  create a basic namespace for the deskcut object
if (!net) var net = {};
if (!net.evelands) net.evelands={};
if (!net.evelands.deskcut )
{
  // Now create the object
  net.evelands.deskcut = 
  {
    prefs : Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService)
                    .getBranch("extensions.deskcut."),
    menu : null,

    startup: function()
    {
      
      // load the context menu event for our items
      if (!this.menu)
      {
          this.menu = document.getElementById("contentAreaContextMenu");
      }
      if (this.menu != null)
      {
          this.menu.addEventListener("popupshowing",function(){ net.evelands.deskcut.showHideContextItems() },false);         
      }
      if (!this.prefs)
      {
          this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
              .getService(Components.interfaces.nsIPrefService)
              .getBranch("extensions.deskcut.");
      }
      // get the stringBundle from the .xul 
      // var deskcutBundle = document.getElementById("deskcutStrings");
    },
   
    shutdown: function()
    {
        this.menu = null;
        this.prefs = null;
    },
  
    // <summary>
    //   Show or hide the deskcut context menu items based on the context menu showing.
    //   Don't show deskcutCreate if text selected, on a link, on an image or on text
    //   Don't show deskcutCreateLink if not on a link
    // </summary>
    showHideContextItems: function()
    {
      if (gContextMenu)
      {
        document.getElementById('deskcutCreate').hidden = (gContextMenu.isTextSelected || gContextMenu.onLink || gContextMenu.onImage || gContextMenu.onTextInput);
        document.getElementById('deskcutCreateLink').hidden = (!gContextMenu.onLink);
      }
    },

    // <summary>
    //   Main function to create the deskCut.
    // </summary>
    // <returns type="Boolean">
    //   True if deskCut able to be created.
    // </returns>
    create: function()
    {
        var retVal = false;
        var url = this.getHref();

        if (url)
        {
            var favicon = this.getFaviconUrl(url);

            var path = this.getPath();
            if (path)
            {
                var fileName = this.getName(path);
                if (fileName)
                {
                    // now deal with file overwriting
                    if (this.fileExists(fileName, path))
                    {

                        var overwriteScheme = this.prefs.getCharPref("overwriteScheme");
                        var makeUnique = this.prefs.getCharPref("makeUniqueScheme");
                        if (overwriteScheme == "ASK")
                        {
                            // pop up a dialog box.  Return the same filename to overwrite it,
                            // a different filename if 'MakeUnique' selected,
                            // and empty string to cancel
                            var fileName = this.askOverwriteQuestion(path, filename);
                            if (fileName)
                            {
                                retVal = this.createShortcut(url, path, fileName, favicon);
                            }
                        }
                        else if (overwriteScheme == "ALWAYS")
                        {
                            if (makeUnique != "NONE")
                            {
                                fileName = this.makeFileNameUnique(path, fileName, makeUnique);
                            }
                            retVal = this.createShortcut(url, path, fileName, favicon); 
                        }
                        else if (overwriteScheme == "NEVER" && makeUnique != "NONE")
                        {
                            fileName = this.makeFileNameUnique(path, fileName, makeUnique);
                            retVal = this.createShortcut(url, path, fileName, favicon);
                        }
                    }
                    else
                    {
                        retVal = this.createShortcut(url, path, fileName, favicon);
                    }

                    this.postCreate(url, retVal);
                }
                else
                {
                    this.doError("fileName");
                }
            }

        }
        else
        {
            this.doError("url");
        }

        return retVal;
    },

    askOverwriteQuestion : function(path,  fileName)
    {
        // TODO : finish askOverwriteQuestion
        // need to diaplay a "file exists, overwrite?" box 
        //

    },

    // <summary>
    // Given a URL as a string, find it's favicon
    // </summary>
    // <param name="" type=""></param>
    // <returns type="string">The URL of the favicon as a string, "" if no find.</returns>
    getFaviconUrl : function(url)
    {
        var retVal = "";
        var ios = Components.classes['@mozilla.org/network/io-service;1']
            .getService(Components.interfaces.nsIIOService);
        var uri = ios.newURI(url, null, null);
        
        var faviconService = Components.classes["@mozilla.org/browser/favicon-service;1"]
            .getService(Components.interfaces.nsIFaviconService);
        

        var iconURL;
	    try
	    {
		    iconURL = faviconService.getFaviconForPage (uri);
	    } 
        catch (e) 
        {
        }
	    
        if (iconURL)
            retVal = iconURL.spec;
        return retVal;
    },


    makeFileNameUnique : function(path, fileName, makeUniqueScheme)
    {
        var dateStamp = this.getDateTimeStamp();
        // a stupid hack;  make several 
        // attempts to generate a unique filename
        // if it keeps failing for some wacky reason, just return the empty string
        var itr = 0;
        var name = fileName.substr(0, fileName.lastIndexOf('.'));
        var ext = fileName.substr(fileName.lastIndexOf('.'));
        do
        {
            if (makeUniqueScheme == "TIMESTAMP")
                fileName = name + this.getDateTimeStamp() + ext;
            else
                fileName = name + "(" +itr +")" + ext;
            itr=itr+1;
            if (itr > 25)
            {
                break;
            }
        }
        while (this.fileExists(fileName, path));

        // make sure we didn't drop out due to multiple failed attempts
        if (this.fileExists(fileName, path))
        {
            fileName = "";
        }

        return fileName;
    },

    // <summary>
    //   Generate a dateTimestamp string enclosed in brackets
    // </summary>
    getDateTimeStamp : function()
    {
        var t = new Date();
        var retVal = '(' + t.getFullYear()+'';
        retVal=retVal+t.getMonth()+1+'';
        retVal=retVal+t.getDate()+'';
        retVal=retVal+t.getHours()+'';
        retVal=retVal+t.getMinutes()+'';
        retVal=retVal+t.getSeconds()+'';
        retVal=retVal+this.pad(t.getMilliseconds()+'',3,"0");
        retVal=retVal+')'
        return retVal;
    },


    // <summary>
    //   Get the URL under the cursor when one of the deskCut context items are clicked.
    // </summary>
    // <returns type="String">
    //   The URL the shortcut to points to.
    //   Returns "" in case of error.
    // </returns>
    getHref: function()
    {
        var retVal = "";
        if (gContextMenu)
        {
            if (gContextMenu.onLink)
            {
                retVal = typeof(gContextMenu.linkURL) == "function"  ? gContextMenu.linkURL() : gContextMenu.linkURL;
            }
            else
            {
                retVal = gBrowser.currentURI.spec;
            }
        }
        return retVal;
    },

    // <summary>
    //   Find the file path to the directory where shortcuts will be saved.
    //   Prompt for path if needed and update user prefs if 'rememberLast' user pref is set.
    // </summary>
    // <returns type="String">
    //   The file path where the shortcut will be created.
    //   Returns "" in case of error.
    // </returns>
    getPath: function()
    {
        var retVal = "";

        var dirScheme = this.prefs.getCharPref("dirScheme");
        var deskPath = this.prefs.getCharPref("deskPath");
        var rememberLast = this.prefs.getBoolPref("rememberLast");
        if ((dirScheme == "SET" && deskPath) || (dirScheme == "ASK" &&  rememberLast == true && deskPath) )
        {
            retVal = deskPath;
        }
        else
        {
            var dlgString = this.getLocalizedString("browsePathDialogTitle");
            var tmpDir = this.browseForPath(dlgString);
            if (tmpDir)
            {
                retVal = tmpDir;
                // if we don't have a path set in prefs, set it now...
                if (!deskPath || rememberLast)
                {
                    this.prefs.setCharPref("deskPath",tmpDir);
                }
            }
            else
            {
                this.doError("path");
            }
        }

        return retVal;
        
    },

    // <summary>
    //   Given a base path, get the filename based on user prefs.  
    //   Do Not resolve overwrite issues in this function.
    // </summary>
    // <param name="path" type="String">
    //   Path to directory the shortcut will be created in.
    // </param>
    // <returns type="String">
    //   Filename based on path provided and user prefs.
    //   Returns "" in case of error.
    // </returns>
    getName: function(path)
    {
        var retVal = "";
        var isLink = false;
        if (gContextMenu)
        {
            if (gContextMenu.onLink)
            {
                isLink = true;
            }
            else
            {
                isLink = false;
            }
        }
            
        var nameScheme = this.prefs.getCharPref("nameScheme");
        var addDate = this.prefs.getBoolPref("addDate");
        var addDateBefore = this.prefs.getBoolPref("addDateBefore");
        var dateFormat = this.prefs.getCharPref("dateFormat");
        var invalidScheme = this.prefs.getCharPref("invalidScheme");
        var replaceChar = this.prefs.getCharPref("replaceChar");

        // if nameScheme is 'NAME' or 'URL' , get name from page info,
        //   if 'SET' or undefined, prompt for it...
        if (nameScheme == "NAME")
        {
            if (isLink)
            {
                retVal = gContextMenu.linkText();
            }
            else 
            {
                retVal = gBrowser.contentDocument.title;
            }
        }
        else if (nameScheme == "URL")
        {
            if (isLink)
            {
                retVal = gContextMenu.linkURL();
            }
            else 
            {
                retVal = gBrowser.currentURI.spec;
            }
        }
        else
        {
            // pop up the name dialog box...
            retVal = this.promptForName(addDateBefore,dateFormat,invalidScheme,replaceChar);
        }
        // now clean up filename...        
        retVal = this.cleanAndApplyFileNamePrefs(retVal);

        // add the file extension
        retVal = this.addFileExtension(retVal);

        return retVal;
    },

    addFileExtension: function(fileName)
    {
        var retVal = "";
        var platform = this.getPlatform();
        if (platform == "win")
        {
            if (!this.endsWith(fileName, ".url"))
            {
                retVal = fileName + ".url";
            }
        }
        else if (platform == "nix")
        {
            if (!this.endsWith(fileName,".desktop"))
            {
                retVal =  fileName + ".desktop"
            }
        }
        else if (platform == "mac")
        {
            if (!this.endsWith(fileName,".webloc"))
            {
                retVal =  fileName + ".webloc"
            }
        }

        return retVal;
    },

    endsWith: function(fileName, searchString)
    {
        var retVal = false;
        // does the searchString exist in filename
        var strPos = fileName.search(searchString);
        if (strPos != -1)
        {
            if (fileName.length == (strPos + searchString) )
            {
                retVal = true;
            }
        }

        return retVal;
    },

    fileExists: function(fileName, filePath)
    {
        var retVal = false;
        var fullPath = this.combineFileNameAndPath(fileName,filePath);

        var file = Components.classes["@mozilla.org/file/local;1"].
            createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(fullPath);
        if (file.exists())
        {
            retVal = true;
        }
        return retVal;
    },

    combineFileNameAndPath: function(fileName, filePath)
    {
        var retVal = "";
        var platform = this.getPlatform();
        if (platform == "win")
        {
            retVal = filePath + "\\" + fileName;
        }
        else if (platform == "nix" || platform == "mac")
        {
            retVal = filePath + "//" + fileName;
        }

        return retVal;
    },

    // <summary>
    //   Given a url, a file path and a file name, create a valid desktop shortcut.
    //   NOTE: at this point we still need to check for file existance when writing, but 
    //   we ALWAYS overwrite.  The logic to make filenames unique or bail out
    //   is in the main create function after the comment 'now deal with file overwriting'
    // </summary>
    // <param name="url" type="String">
    //   The URL the shortcut to points to.
    // </param>
    // <param name="path" type="String">
    //   The path to the directory the shortcut will be created in.
    // </param>
    // <param name="fileName" type="String">
    //   The filename to use when creating the shortcut.  This has already been cleaned of illegal
    //   characters and any prefs adding dates, etc applied
    // </param>
    // <param name="favicon" type="String">
    //   The URL of the favicon to use if found, "" if not found
    // </param>
    // <returns type="Boolean">
    //   Return true in case of successful creation, false if error.
    // </returns>
    createShortcut: function(url, path, fileName, favicon )
    {
        try
        {
            var retVal = false;
            var fullFileName = this.combineFileNameAndPath(fileName,path);

            var file = Components.classes["@mozilla.org/file/local;1"].
                createInstance(Components.interfaces.nsILocalFile);
            

            file.initWithPath(fullFileName);


            if (file.exists() )
                file.remove(false);

            file.create(0x00, 0644);
            var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
                createInstance(Components.interfaces.nsIFileOutputStream);

            // mode should really be 0664... read/write owner, read group, read others... 
            outputStream.init(file, 0x20 | 0x02, 00644,null);
            //outputStream.init(file, 0x20 | 0x02, 00004,null);
            
            var converterOutputStream = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
                createInstance(Components.interfaces.nsIConverterOutputStream);
               
            // replace unsupported chars instead of throwing an exception:
            //  https://developer.mozilla.org/en/writing_textual_data
            converterOutputStream.init(outputStream, "UTF-8", 0,"?".charCodeAt(0));
            //converterOutputStream.init(outputStream, "UTF-8", 0, 0x0000);
            
            var platform = this.getPlatform();
            var outString = "";
            if (platform == "win")
            {
                outString = "[InternetShortcut]\r\nURL=" + url + "\r\n";
                if (favicon)
                {
                    outString = outString + "IconFile=" + favicon + "\r\n";
                }

            }
            else if (platform == "nix")
            {
                outString = "[Desktop Entry]\nEncoding=UTF-8\nIcon=text-html\nType=Link\nName=" + fileName + "\nURL=" + url + "\n";
            }
            else if (platform == "mac")
            {
                outString = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE plist PUBLIC \"-//Apple//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n<plist version=\"1.0\">\n<dict>\n<key>URL</key>\n<string>" + url + "</string>\n</dict>\n</plist>\n"; 
            }
        
            converterOutputStream.writeString(outString);
            converterOutputStream.close();
            retVal = true;
        }
        
        catch (ex)
        {
            alert('Bad things happened: '+ex);
            retVal = false;
        }
          
        return retVal;
    },


    // <summary>
    //   Perform any requested user notification after an attempt at creating a deskCut.
    // </summary>
    // <param name="url" type="String">
    //   The URL we attempted to create a deskCut to.
    // </param>
    // <param name="success" type="Boolean">
    //   Was the attempt to create the deskCut successful.
    // </param>
    postCreate: function(url, success)
    {

        var alertMessagebox = this.prefs.getBoolPref("alertMessagebox");
        var alertAudio = this.prefs.getBoolPref("alertAudio");
        if (alertMessagebox)
        {
            this.showMessageBoxAlert(url, success);
        }
        if (alertAudio)
        {
            this.audioAlert(success);
        }

    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    showMessageBoxAlert : function(url, success)
    {
        var outStr =  this.getLocalizedString("postCreateAlertPre");
        outStr = outStr + " " + url + " ";
        if (success)
        {
            outStr = outStr + this.getLocalizedString("postCreateAlertOk");
        }
        else
        {
            outStr = outStr + this.getLocalizedString("postCreateAlertFail");
        }
        alert(outStr);

    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    audioAlert: function(success)
    {
        // TODO : finish audioAlert
         var sound = Components.classes["@mozilla.org/sound;1"].createInstance();
         if (sound) 
         {
             sound.QueryInterface(Components.interfaces.nsISound);
             sound.init();
         }
        
            var wavPath = "";
            if (success)
            {
                wavPath = this.prefs.getCharPref("wavPathSuccess");
            }
            else
            {
                 wavPath = this.prefs.getCharPref("wavPathFail");
            }
            var file = Components.classes["@mozilla.org/file/local;1"].
                createInstance(Components.interfaces.nsILocalFile);
            file.initWithPath (wavPath);
            if (file.exists())
            {
                var ioService = Components.classes["@mozilla.org/network/io-service;1"].
                    getService(Components.interfaces.nsIIOService);
                var url = ioService.newURI("file:///"+wavPath, "", null);
                sound.play(url);
                url = null;
                ioService = null;
            }
        
    },

    // <summary>
    //   Report an error.
    // </summary>
    // <param name="error" type="String">
    //   Error message to report.
    // </param>
    doError: function(error)
    {
        // TODO : finish doError
    },

    // ------------------------- UTILITY FXNS -------------------------
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    getPlatform: function()
    {
        // currently supported
        // "WINNT"
        // "Linux"
        // "Darwin"
        //
        var retVal = "unk";
        var osVal = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS.toLowerCase();
        var platVal = navigator.platform.toLowerCase();

        if (osVal == "winnt" || platVal == "win32" || platVal == "windows")
        {
            retVal = "win";
        }
        else if (osVal == "darwin" || platVal == "mac68k" || platVal == "macppc" || platVal == "macintosh")
        {
            retVal = "mac";
        }
        else if (osVal = "linux" || osVal == "freebsd" || osVal == "openbsd" || osVal == "netbsd" || osVal == "sunos" || platVal == "x11")
        {
            retVal = "nix";
        }
        return retVal;
    },

    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    getOS: function()
    {
        var retVal = "unk";
        var platForm = this.getPlatform();
        var ua = navigator.userAgent.toLowerCase();

        if (platForm == "win")
        {
            if (ua.indexOf("win95") > -1 || ua.indexOf("windows 95") > -1)
            {
                retVal = "w95";
            }
            else if (ua.indexOf("win98") > -1 || ua.indexOf("windows 98") > -1)
            {
                retVal = "w98";
            }
            else if (ua.indexOf("win 9x 4.90") > -1|| ua.indexOf("windows me") > -1)
            {
                retVal = "wme";
            }
            else if (ua.indexOf("winnt") > -1 || ua.indexOf("windows nt") > -1 || ua.indexOf("winnt4.0") > -1 || ua.indexOf("windows nt 4.0") > -1)
            {
                retVal = "wnt";
            }
            else if (ua.indexOf("windows nt 5.0") > -1|| ua.indexOf("windows 2000") > -1)
            {
                retVal = "w2k";
            }
            else if (ua.indexOf("windows nt 5.1") > -1 || ua.indexOf("windows xp") > -1)
            {
                retVal = "wxp";
            }
            else if (ua.indexOf("windows nt 6.0") > -1)
            {
                retVal = "vis";
            }
            
        }
        else if (platForm == "mac")
        {
            if(navigator.plugins["Default Plugin Carbon.cfm"] || ua.indexOf("omniweb") != -1 || ua.indexOf('os x') != -1)
            {
                retVal = "osx";
            }
            else if (ua.indexOf("mac_68000") > -1 || ua.indexOf("68k") > -1)
            {
                retVal = "68k";
            }
            else if (ua.indexOf("mac_powerpc") > -1 || ua.indexOf("ppc") > -1 )
            {
                retVal = "ppc";
            }
            
        }
        else if (platForm == "nix")
        {
            if (osVal = "linux")
            {
                retVal = "lin";
            }
            else if (osVal == "freebsd" || osVal == "openbsd" || osVal == "netbsd")
            {
                retVal = "bsd";
            }
            else if (osVal == "sunos")
            {
                retVal = "sun";
            }
        }

        return retVal;
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    // remove invalid filename chars
    stripBadChars: function(strToClean)
    {
        //strToClean = strToClean.replace(/[\\\/\:\*\?\"\<\>\|]/g, '');
        //strToClean = strToClean.replace(/(^[\s]+)|([\s]+$)/g, '');
        //return strToClean;
        return this.replaceBadChars(strToClean,'');
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    // replace invalid filename chars
    replaceBadChars: function(strToClean, replaceChr)
    {
        if (this.hasBadChars(replaceChr) )
        {
            strToClean = this.stripBadChars(strToClean);
        }
        else
        {
            // OK; need to yank anything that will kill our happy shortcut filename
            strToClean = strToClean.replace(/[\\\/\:\*\?\"\<\>\|]/g, replaceChr);
            strToClean = strToClean.replace(/(^[\s]+)|([\s]+$)/g, replaceChr);
        }
        return strToClean;   
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    hasBadChars: function(strToCheck)
    {
        var re1 = /[\\\/\:\*\?\"\<\>\|]/g;
        var re2 = /(^[\s]+)|([\s]+$)/g;
        return re1.test(strToCheck) || re2.test(strToCheck);
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    encodeBadChars: function(strToEncode)
    {
        return encodeURIComponent(strToEncode);
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    checkLen: function(strToClean, length)
    {
        if (strToClean.length > length)
        {
            strToClean = strToClean.substring(0,length);
        }
        return strToClean;
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>    
    getExamplePageUrl: function()
    {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
            .getService(Components.interfaces.nsIWindowMediator);

        var mainWindow = wm.getMostRecentWindow("navigator:browser");
        return mainWindow.gBrowser.selectedBrowser.currentURI.spec; 
            
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    getExamplePageTitle: function()
    {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
            .getService(Components.interfaces.nsIWindowMediator);
        var mainWindow = wm.getMostRecentWindow("navigator:browser");
        return mainWindow.gBrowser.selectedBrowser.contentTitle; 
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    formatDate: function(rawDate, mask) 
    {
        var dayNames=new Array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat","Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
        var monthNames=new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec","January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");

        var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g;
        var timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g;
        var timezoneClip = /[^-+\dA-Z]/g;

        var	d = rawDate["getDate"]();
        var	D = rawDate["getDay"]();
        var	m = rawDate["getMonth"]();
        var	y = rawDate["getFullYear"]();
        var	H = rawDate["getHours"]();
        var M = rawDate["getMinutes"]();
        var s = rawDate["getSeconds"]();
        var	L = rawDate["getMilliseconds"]();
        var	o = rawDate.getTimezoneOffset();
        var	flags =
        {
            d:    d,
            dd:   this.pad(d),
            ddd:  dayNames[D],
            dddd: dayNames[D + 7],
            m:    m + 1,
            mm:   this.pad(m + 1),
            mmm:  monthNames[m],
            mmmm: monthNames[m + 12],
            yy:   String(y).slice(2),
            yyyy: y,
            h:    H % 12 || 12,
            hh:   this.pad(H % 12 || 12),
            H:    H,
            HH:   this.pad(H),
            M:    M,
            MM:   this.pad(M),
            s:    s,
            ss:   this.pad(s),
            l:    this.pad(L, 3),
            L:    this.pad(L > 99 ? Math.round(L / 10) : L),
            t:    H < 12 ? "a"  : "p",
            tt:   H < 12 ? "am" : "pm",
            T:    H < 12 ? "A"  : "P",
            TT:   H < 12 ? "AM" : "PM",
            Z:    (String(rawDate).match(timezone) || [""]).pop().replace(timezoneClip, ""),
            o:    (o > 0 ? "-" : "+") + this.pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
            S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
        };

        return mask.replace(token, function ($0) { return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);	});
         
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    pad: function(val, len) 
    {
        val = String(val);
        len = len || 2;
        while (val.length < len)
        {
            val = "0" + val;
        }
        return val;
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    getDesktop: function()
    {
        var retVal = '';
        var dirService = Components.classes['@mozilla.org/file/directory_service;1']
            .getService(Components.interfaces.nsIProperties);
        var desktop = dirService.get('Desk', Components.interfaces.nsIFile);
        if (desktop.exists()) 
        {
            retVal =  desktop.path; 
        }
        return retVal;
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    getLocalizedString: function(name)
    {
        var bundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
            .getService(Components.interfaces.nsIStringBundleService)  
            .createBundle("chrome://deskcut/locale/deskcut.properties");
    
       return bundle.GetStringFromName(name);
        
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    //prompt for a path using the title passed in
    browseForPath: function(dialogTitle)
    {
        var retVal = '';
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"]
            .createInstance(nsIFilePicker);
        fp.init(window, dialogTitle , nsIFilePicker.modeGetFolder);

        var rv = fp.show();
        if (rv == nsIFilePicker.returnOK) 
        {
            retVal = fp.file.path;
        }
        return retVal;
    },

    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    // prompt for a file using title, filterString and filterType
    // filePrompt ("Wav file to play","WAV FILES","*.wav")
    browseForFile: function(dialogTitle, filterName, filterType)
    {
        var retVal = "";
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"]
            .createInstance(nsIFilePicker);
        fp.init(window, dialogTitle , nsIFilePicker.modeOpen);

        if (!filterName || !filterType)
        {
            fp.appendFilters("All Files","*.*");
        }
        else
        {
            fp.appendFilter(filterName,filterType);
        }
        var rv = fp.show();
        if (rv == nsIFilePicker.returnOK) 
        {
            retVal = fp.file.path;
        }
        return retVal;
    },
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    // load deskcutName.xul passing the params needed to display the name
    // NOTE : returned name IS NOT filtered or stripped of bad chars
    // will still need to call 
    promptForName: function()
    {
        var retVal = "";
        var params = {out:null};       
        window.openDialog("chrome://deskcut/content/deskcutName.xul", "",
                "chrome, dialog, modal, centerscreen, resizable=yes", params).focus();
        if (params.out) 
        {
            retVal = params.out;
        }
        return retVal;
    },
    
    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    nameDialogOnLoad: function()
    {
    },

    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    nameDialogOnAccept: function()
    {
        window.arguments[0].out = document.getElementById('net.evelands.deskcut.nameDialog.name').value
        return true;
    },

    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    nameDialogOnCancel: function()
    {
        window.arguments[0].out = "";
        return true;
    },

    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    nameDialogUpdateExample: function()
    {
        var outStr = document.getElementById('net.evelands.deskcut.nameDialog.name').value;

        outStr = this.cleanAndApplyFileNamePrefs(outStr);
        document.getElementById('net.evelands.deskcut.nameDialog.example').value = outStr
    },

    // <summary>
    // </summary>
    // <param name="" type=""></param>
    // <returns type=""></returns>
    cleanAndApplyFileNamePrefs: function(fileName)
    {
        var addDate = this.prefs.getBoolPref("addDate");
        var invalidScheme = this.prefs.getCharPref("invalidScheme");
        var replaceChar = this.prefs.getCharPref("replaceChar");

        // first off if the filename passed in is more than 200 chars trim it
        var retVal = this.checkLen(fileName,200);

        if (addDate)
        {
            var addDateBefore = this.prefs.getBoolPref("addDateBefore");
            var dateFormat = this.prefs.getCharPref("dateFormat");
            
        
            var tDate = new Date();
            var dateTxt = this.formatDate(tDate,dateFormat);
            if (addDateBefore)
            {
                retVal = dateTxt + retVal;
            }
            else
            {
                retVal = retVal + dateTxt;
            }
        }
        if (invalidScheme == "STRIP")
        {
            retVal = this.stripBadChars(retVal);
        }
        else if (invalidScheme == "REPLACE")
        {
            retVal = this.replaceBadChars(retVal,replaceChar);
        }
        else if (invalidScheme == "ENCODE")
        {
            retVal = this.encodeBadChars(retVal);
        }
        return retVal;
    }

  }
}


// Install load and unload handlers:
window.addEventListener("load", function(e){net.evelands.deskcut.startup();}, false);
window.addEventListener("unload", function(e){net.evelands.deskcut.shutdown();}, false);

